/*
  changes the volume in a stream
  Copyright (C) 1998  Martin Vogt

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation.

  For more information look at the file COPYRIGHT in this package

 */



#include <devices/volumeDevice.h>


VolumeDevice::VolumeDevice() {
  volumeFilter=new VolumeFilter();
  configArray=new DeviceConfigArray();
  vol=100.0;
  lWithFilter=false;
}


VolumeDevice::~VolumeDevice() {
  cout << "destruktor VolumeDevice"<<endl;
  delete configArray;
  delete volumeFilter;
}


char* VolumeDevice::getNodeName() {
  return "VolumeDevice";
}



void VolumeDevice::setVolume(int percent) {
  vol=(float) percent;
}


int VolumeDevice::getVolume() {
  return (int) vol;
}


void VolumeDevice::setFilter(int on) {
  lWithFilter=on;
}


int VolumeDevice::getFilter() {
  return lWithFilter;
}

    
void VolumeDevice::writeIn(NodeDevice* source,DeviceConfig* buf) {
  YafAudioInfo* info=buf->getAudioInfo();


  info->setVolume(vol);
  // now we deliver to the listeners
  if (lWithFilter) {
    // if we should transform the volume to a lowser value
    // we make software volume, instead nothing
    // is to be change, thus we do nothing!
    // This is a speed optimization (8 % on a P166MMX)
    if (vol < 100.0) {
      volumeFilter->transform(buf);
      info->setVolume(100.0);
    }
  }

  configArray->clear();
  configArray->setDeviceConfigAt(0,buf);
  configArray->setEntries(1);


  writeOut(configArray);

}


